Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90	(revision 2594)
@@ -12,11 +12,5 @@
                      prad,pg,pr,pcpp,iflag_phys)
   USE dimphy, ONLY: init_dimphy
-  USE mod_grid_phy_lmdz, ONLY: klon_glo,  & ! number of atmospheric columns (on full grid)
-                               regular_lonlat  ! regular longitude-latitude grid type
-  USE mod_phys_lmdz_para, ONLY: klon_omp, & ! number of columns (on local omp grid)
-                                klon_omp_begin, & ! start index of local omp subgrid
-                                klon_omp_end, & ! end index of local omp subgrid
-                                klon_mpi_begin ! start indes of columns (on local mpi grid)
-  USE geometry_mod, ONLY : init_geometry
+  USE inigeomphy_mod, ONLY: inigeomphy
   USE infotrac, ONLY: nqtot
   USE comcstphy, ONLY: rradius, & ! planet radius (m)
@@ -24,11 +18,4 @@
                        rg, & ! gravity
                        rcpp  ! specific heat of the atmosphere
-!  USE phyaqua_mod, ONLY: iniaqua
-  USE physics_distribution_mod, ONLY : init_physics_distribution
-  USE regular_lonlat_mod, ONLY : init_regular_lonlat, &
-                                 east, west, north, south, &
-                                 north_east, north_west, &
-                                 south_west, south_east
-  USE mod_interface_dyn_phys, ONLY :  init_interface_dyn_phys
   USE infotrac_phy, ONLY: init_infotrac_phy
   USE nrtype, ONLY: pi
@@ -68,165 +55,17 @@
   CHARACTER (LEN=20) :: modname='iniphysiq'
   CHARACTER (LEN=80) :: abort_message
-  REAL :: total_area_phy, total_area_dyn
-
-  ! boundaries, on global grid
-  REAL,ALLOCATABLE :: boundslon_reg(:,:)
-  REAL,ALLOCATABLE :: boundslat_reg(:,:)
-
-  ! global array, on full physics grid:
-  REAL,ALLOCATABLE :: latfi_glo(:)
-  REAL,ALLOCATABLE :: lonfi_glo(:)
-  REAL,ALLOCATABLE :: cufi_glo(:)
-  REAL,ALLOCATABLE :: cvfi_glo(:)
-  REAL,ALLOCATABLE :: airefi_glo(:)
-  REAL,ALLOCATABLE :: boundslonfi_glo(:,:)
-  REAL,ALLOCATABLE :: boundslatfi_glo(:,:)
-
-  ! local arrays, on given MPI/OpenMP domain:
-  REAL,ALLOCATABLE,SAVE :: latfi(:)
-  REAL,ALLOCATABLE,SAVE :: lonfi(:)
-  REAL,ALLOCATABLE,SAVE :: cufi(:)
-  REAL,ALLOCATABLE,SAVE :: cvfi(:)
-  REAL,ALLOCATABLE,SAVE :: airefi(:)
-  REAL,ALLOCATABLE,SAVE :: boundslonfi(:,:)
-  REAL,ALLOCATABLE,SAVE :: boundslatfi(:,:)
-!$OMP THREADPRIVATE (latfi,lonfi,cufi,cvfi,airefi,boundslonfi,boundslatfi)
-
-  ! Initialize Physics distibution and parameters and interface with dynamics
-  CALL init_physics_distribution(regular_lonlat,4, &
-                                 nbp,ii,jj+1,nlayer,communicator)
-  CALL init_interface_dyn_phys
-  
-  ! init regular global longitude-latitude grid points and boundaries
-  ALLOCATE(boundslon_reg(ii,2))
-  ALLOCATE(boundslat_reg(jj+1,2))
-  
-  DO i=1,ii
-   boundslon_reg(i,east)=rlonu(i) 
-   boundslon_reg(i,west)=rlonu(i+1) 
-  ENDDO
-
-  boundslat_reg(1,north)= PI/2 
-  boundslat_reg(1,south)= rlatv(1)
-  DO j=2,jj
-   boundslat_reg(j,north)=rlatv(j-1) 
-   boundslat_reg(j,south)=rlatv(j) 
-  ENDDO
-  boundslat_reg(jj+1,north)= rlatv(jj) 
-  boundslat_reg(jj+1,south)= -PI/2
-
-  ! Write values in module regular_lonlat_mod
-  CALL init_regular_lonlat(ii,jj+1, rlonv(1:ii), rlatu, &
-                           boundslon_reg, boundslat_reg)
-
-  ! Generate global arrays on full physics grid
-  ALLOCATE(latfi_glo(klon_glo),lonfi_glo(klon_glo))
-  ALLOCATE(cufi_glo(klon_glo),cvfi_glo(klon_glo))
-  ALLOCATE(airefi_glo(klon_glo))
-  ALLOCATE(boundslonfi_glo(klon_glo,4))
-  ALLOCATE(boundslatfi_glo(klon_glo,4))
-
-  IF (klon_glo>1) THEN ! general case
-    ! North pole
-    latfi_glo(1)=rlatu(1)
-    lonfi_glo(1)=0.
-    cufi_glo(1) = cu(1)
-    cvfi_glo(1) = cv(1)
-    boundslonfi_glo(1,north_east)=0
-    boundslatfi_glo(1,north_east)=PI/2
-    boundslonfi_glo(1,north_west)=2*PI
-    boundslatfi_glo(1,north_west)=PI/2
-    boundslonfi_glo(1,south_west)=2*PI
-    boundslatfi_glo(1,south_west)=rlatv(1)
-    boundslonfi_glo(1,south_east)=0
-    boundslatfi_glo(1,south_east)=rlatv(1)
-    DO j=2,jj
-      DO i=1,ii
-        k=(j-2)*ii+1+i
-        latfi_glo((j-2)*ii+1+i)= rlatu(j)
-        lonfi_glo((j-2)*ii+1+i)= rlonv(i)
-        cufi_glo((j-2)*ii+1+i) = cu((j-1)*(ii+1)+i)
-        cvfi_glo((j-2)*ii+1+i) = cv((j-1)*(ii+1)+i)
-        boundslonfi_glo(k,north_east)=rlonu(i)
-        boundslatfi_glo(k,north_east)=rlatv(j-1)
-        boundslonfi_glo(k,north_west)=rlonu(i+1)
-        boundslatfi_glo(k,north_west)=rlatv(j-1)
-        boundslonfi_glo(k,south_west)=rlonu(i+1)
-        boundslatfi_glo(k,south_west)=rlatv(j)
-        boundslonfi_glo(k,south_east)=rlonu(i)
-        boundslatfi_glo(k,south_east)=rlatv(j)
-      ENDDO
-    ENDDO
-    ! South pole
-    latfi_glo(klon_glo)= rlatu(jj+1)
-    lonfi_glo(klon_glo)= 0.
-    cufi_glo(klon_glo) = cu((ii+1)*jj+1)
-    cvfi_glo(klon_glo) = cv((ii+1)*jj-ii)
-    boundslonfi_glo(klon_glo,north_east)= 0
-    boundslatfi_glo(klon_glo,north_east)= rlatv(jj)
-    boundslonfi_glo(klon_glo,north_west)= 2*PI
-    boundslatfi_glo(klon_glo,north_west)= rlatv(jj)
-    boundslonfi_glo(klon_glo,south_west)= 2*PI
-    boundslatfi_glo(klon_glo,south_west)= -PI/2
-    boundslonfi_glo(klon_glo,south_east)= 0
-    boundslatfi_glo(klon_glo,south_east)= -Pi/2
-
-    ! build airefi(), mesh area on physics grid
-    CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,aire,airefi_glo)
-    ! Poles are single points on physics grid
-    airefi_glo(1)=sum(aire(1:ii,1))
-    airefi_glo(klon_glo)=sum(aire(1:ii,jj+1))
-
-    ! Sanity check: do total planet area match between physics and dynamics?
-    total_area_dyn=sum(aire(1:ii,1:jj+1))
-    total_area_phy=sum(airefi_glo(1:klon_glo))
-    IF (total_area_dyn/=total_area_phy) THEN
-      WRITE (lunout, *) 'iniphysiq: planet total surface discrepancy !!!'
-      WRITE (lunout, *) '     in the dynamics total_area_dyn=', total_area_dyn
-      WRITE (lunout, *) '  but in the physics total_area_phy=', total_area_phy
-      IF (abs(total_area_dyn-total_area_phy)>0.00001*total_area_dyn) THEN
-        ! stop here if the relative difference is more than 0.001%
-        abort_message = 'planet total surface discrepancy'
-        CALL abort_gcm(modname, abort_message, 1)
-      ENDIF
-    ENDIF
-  ELSE ! klon_glo==1, running the 1D model
-    ! just copy over input values
-    latfi_glo(1)=rlatu(1)
-    lonfi_glo(1)=rlonv(1)
-    cufi_glo(1)=cu(1)
-    cvfi_glo(1)=cv(1)
-    airefi_glo(1)=aire(1,1)
-    boundslonfi_glo(1,north_east)=rlonu(1)
-    boundslatfi_glo(1,north_east)=PI/2
-    boundslonfi_glo(1,north_west)=rlonu(2)
-    boundslatfi_glo(1,north_west)=PI/2
-    boundslonfi_glo(1,south_west)=rlonu(2)
-    boundslatfi_glo(1,south_west)=rlatv(1)
-    boundslonfi_glo(1,south_east)=rlonu(1)
-    boundslatfi_glo(1,south_east)=rlatv(1)
-  ENDIF ! of IF (klon_glo>1)
-
-!$OMP PARALLEL
-  ! Now generate local lon/lat/cu/cv/area/bounds arrays
-  ALLOCATE(latfi(klon_omp),lonfi(klon_omp),cufi(klon_omp),cvfi(klon_omp))
-  ALLOCATE(airefi(klon_omp))
-  ALLOCATE(boundslonfi(klon_omp,4))
-  ALLOCATE(boundslatfi(klon_omp,4))
 
 
-  offset = klon_mpi_begin - 1
-  airefi(1:klon_omp) = airefi_glo(offset+klon_omp_begin:offset+klon_omp_end)
-  cufi(1:klon_omp) = cufi_glo(offset+klon_omp_begin:offset+klon_omp_end)
-  cvfi(1:klon_omp) = cvfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
-  lonfi(1:klon_omp) = lonfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
-  latfi(1:klon_omp) = latfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
-  boundslonfi(1:klon_omp,:) = boundslonfi_glo(offset+klon_omp_begin:offset+klon_omp_end,:)
-  boundslatfi(1:klon_omp,:) = boundslatfi_glo(offset+klon_omp_begin:offset+klon_omp_end,:)
+  ! --> initialize physics distribution, global fields and geometry
+  ! (i.e. things in phy_common or dynphy_lonlat)
+  CALL inigeomphy(ii,jj,nlayer, &
+               nbp, communicator, &
+               rlatu,rlatv, &
+               rlonu,rlonv, &
+               aire,cu,cv)
 
-  ! copy over local grid longitudes and latitudes
-  CALL init_geometry(klon_omp,lonfi,latfi,boundslonfi,boundslatfi, &
-                     airefi,cufi,cvfi)
-
+  ! --> now initialize things specific to the phymar physics package
+  
+!$OMP PARALLEL
 
   ! Initialize tracer names, numbers, etc. for physics
Index: /LMDZ5/branches/testing/libf/phydev/iophy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/iophy.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phydev/iophy.F90	(revision 2594)
@@ -44,5 +44,5 @@
                                 jj_nb, jj_begin, jj_end, ii_begin, ii_end, &
                                 mpi_size, mpi_rank, klon_mpi, &
-                                is_sequential, is_south_pole
+                                is_sequential, is_south_pole_dyn
   USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, klon_glo
   USE print_control_mod, ONLY: lunout, prt_level
@@ -141,5 +141,5 @@
       write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
       write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole
+      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole_dyn
     endif
 
@@ -148,5 +148,5 @@
                             1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
                             klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
-                            io_lat, io_lon,is_south_pole,mpi_rank)
+                            io_lat, io_lon,is_south_pole_dyn,mpi_rank)
 #endif
 !$OMP END MASTER
Index: /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2594)
@@ -88,6 +88,7 @@
 
 ! Number of diagnostics wavelengths (5 SW + 1 LW @ 10 um)
-  INTEGER, PARAMETER :: nwave = 5
+  INTEGER, PARAMETER :: nwave_sw = 5
   INTEGER, PARAMETER :: nwave_lw = 1
+  INTEGER, PARAMETER :: nwave = nwave_sw + nwave_lw
 
 ! Number of modes spectral bands
Index: /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2594)
@@ -1128,8 +1128,10 @@
   ENDDO
 
-  inu=1
+  inu=1         ! visible wavaband
+  mrfspecies=2  ! total aerosol AER	 
   DO i=1, KLON
-     absvisaer(i)=SUM((1-piz_allaer(i,:,:,inu))*tau_allaer(i,:,:,inu))
+     absvisaer(i)=SUM((1-piz_allaer(i,:,mrfspecies,inu))*tau_allaer(i,:,mrfspecies,inu))
   ENDDO
+  STOP
 
   DEALLOCATE(aerosol_name) 
Index: /LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 2594)
@@ -74,5 +74,5 @@
   ! Local
   !
-  INTEGER, PARAMETER :: las = nwave
+  INTEGER, PARAMETER :: las = nwave_sw
   LOGICAL :: soluble
   
Index: /LMDZ5/branches/testing/libf/phylmd/alpale.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/alpale.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/alpale.F90	(revision 2594)
@@ -4,5 +4,5 @@
                     wake_pe, wake_fip,  &
                     Ale_bl, Ale_bl_trig, Alp_bl, &
-                    Ale, Alp )
+                    Ale, Alp, Ale_wake, Alp_wake )
 
 ! **************************************************************
@@ -46,4 +46,5 @@
 !----------------
   REAL, DIMENSION(klon), INTENT(OUT)                         :: Ale, Alp
+  REAL, DIMENSION(klon), INTENT(OUT)                         :: Ale_wake, Alp_wake
 
   include "thermcell.h"
@@ -55,5 +56,4 @@
   INTEGER                                                    :: i, k
   REAL, DIMENSION(klon)                                      :: www
-  REAL, DIMENSION(klon)                                      :: ale_wake, alp_wake
   REAL, SAVE                                                 :: ale_max=1000.
   REAL, SAVE                                                 :: alp_max=2.
Index: /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90	(revision 2594)
@@ -1,6 +1,7 @@
-SUBROUTINE alpale_th ( dtime, lmax_th, t_seri,  &
+SUBROUTINE alpale_th ( dtime, lmax_th, t_seri, cell_area,  &
                        cin, s2, n2,  &
                        ale_bl_trig, ale_bl_stat, ale_bl,  &
-                       alp_bl, alp_bl_stat )
+                       alp_bl, alp_bl_stat, &
+                       proba_notrig, random_notrig)
 
 ! **************************************************************
@@ -27,4 +28,5 @@
 !----------------
   REAL, INTENT(IN)                                           :: dtime
+  REAL, DIMENSION(klon), INTENT(IN)                          :: cell_area
   INTEGER, DIMENSION(klon), INTENT(IN)                       :: lmax_th
   REAL, DIMENSION(klon,klev), INTENT(IN)                     :: t_seri
@@ -37,4 +39,6 @@
   REAL, DIMENSION(klon), INTENT(INOUT)                       :: alp_bl_stat
 
+  REAL, DIMENSION(klon), INTENT(OUT)                         :: proba_notrig, random_notrig
+
   include "thermcell.h"
 
@@ -44,10 +48,38 @@
   LOGICAL, SAVE                                              :: first = .TRUE.
   REAL, SAVE                                                 :: random_notrig_max=1.
-  REAL, DIMENSION(klon)                                      :: proba_notrig, tau_trig, random_notrig
+  REAL, SAVE                                                 :: cv_feed_area
+  REAL                                                       :: birth_number
+  REAL, DIMENSION(klon)                                      :: ale_bl_ref
+  REAL, DIMENSION(klon)                                      :: tau_trig
+  REAL, DIMENSION(klon)                                      :: birth_rate
 !
     !$OMP THREADPRIVATE(random_notrig_max) 
+    !$OMP THREADPRIVATE(cv_feed_area) 
     !$OMP THREADPRIVATE(first)
 !
+ REAL umexp  ! expression of (1.-exp(-x))/x valid for all x, especially when x->0
+ REAL x
+ umexp(x) = max(sign(1.,x-1.e-3),0.)*(1.-exp(-x))/max(x,1.e-3) + &
+            (1.-max(sign(1.,x-1.e-3),0.))*(1.-0.5*x*(1.-x/3.*(1.-0.25*x)))
+!
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+!  JYG, 20160513 : Introduction of the Effective Lifting Power (ELP), which 
+! takes into account the area (cv_feed_area) covered by thermals contributing 
+! to each cumulonimbus.
+!   The use of ELP prevents singularities when the trigger probability tends to
+! zero. It is activated by iflag_clos_bl = 3.
+!   The ELP values are stored in the ALP_bl variable.
+!   
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+!
+!---------------------------------------
+  IF (iflag_clos_bl .LT. 3) THEN
+!---------------------------------------
+!
+!      Original code (Nicolas Rochetin)
+!     --------------------------------
+
     IF (first) THEN
+       random_notrig_max=1.
        CALL getin_p('random_notrig_max',random_notrig_max)
        first=.FALSE.
@@ -155,4 +187,94 @@
           endif !(iflag_clos_bl)
 
+!
+!---------------------------------------
+  ELSEIF (iflag_clos_bl .EQ. 3) THEN  ! (iflag_clos_bl .LT. 3)
+!---------------------------------------
+!
+!      New code with Effective Lifting Power
+!     -------------------------------------
+    IF (first) THEN
+       cv_feed_area = 1.e10   ! m2
+       CALL getin_p('cv_feed_area', cv_feed_area)
+       first=.FALSE.
+    ENDIF
+
+          !-----------Stochastic triggering-----------
+     if (iflag_trig_bl.ge.1) then
+        !
+        IF (prt_level .GE. 10) THEN
+           print *,'cin, ale_bl_stat, alp_bl_stat ', &
+                cin, ale_bl_stat, alp_bl_stat
+        ENDIF
+
+        ! Use ale_bl_stat (Rochetin's code) or ale_bl (old code) according to 
+        ! iflag_trig_bl value.
+        IF (iflag_trig_bl.eq.1) then         ! use ale_bl_stat (Rochetin computation)
+         do i=1,klon
+              ale_bl_ref(i)=ale_bl_stat(i)
+         enddo
+        ELSE IF (iflag_trig_bl.ge.2) then    ! use ale_bl (old computation)
+         do i=1,klon
+              ale_bl_ref(i)=Ale_bl(i)
+         enddo
+        ENDIF ! (iflag_trig_bl.eq.1)
+
+
+        !----Initializations and random number generation
+        do i=1,klon
+           proba_notrig(i)=1.
+           random_notrig(i)=1e6*ale_bl_stat(i)-int(1e6*ale_bl_stat(i))
+           if ( ale_bl_trig(i) .lt. abs(cin(i))+1.e-10 ) then 
+              tau_trig(i)=tau_trig_shallow
+           else
+              tau_trig(i)=tau_trig_deep
+           endif
+        enddo
+        !
+        IF (prt_level .GE. 10) THEN
+           print *,'random_notrig, tau_trig ', &
+                random_notrig, tau_trig
+           print *,'s_trig,s2,n2 ', &
+                s_trig,s2,n2
+        ENDIF
+
+        !----alp_bl computation
+        do i=1,klon
+           if ( (ale_bl_ref(i) .gt. abs(cin(i))+1.e-10) )  then
+              birth_number = n2(i)*exp(-s_trig/s2(i))
+              birth_rate(i) = birth_number/(tau_trig(i)*cell_area(i))
+              proba_notrig(i)=exp(-birth_number*dtime/tau_trig(i))
+              Alp_bl(i) = Alp_bl(i)* &
+                          umexp(-birth_number*cv_feed_area/cell_area(i))/ &
+                          umexp(-birth_number*dtime/tau_trig(i))*  &
+                          tau_trig(i)*cv_feed_area/(dtime*cell_area(i))
+          else 
+              proba_notrig(i)=1.
+              random_notrig(i)=0.
+              alp_bl(i)=0.
+           endif
+        enddo
+
+        !----ale_bl_trig computation
+         do i=1,klon
+           if (random_notrig(i) .ge. proba_notrig(i)) then 
+              ale_bl_trig(i)=ale_bl_ref(i)
+           else
+              ale_bl_trig(i)=0.
+           endif
+         enddo
+
+        !
+        IF (prt_level .GE. 10) THEN
+           print *,'proba_notrig, ale_bl_trig ', &
+                proba_notrig, ale_bl_trig
+        ENDIF
+
+     endif !(iflag_trig_bl .ge. 1)
+
+!---------------------------------------
+  ENDIF ! (iflag_clos_bl .LT. 3)
+!---------------------------------------
+
           IF (prt_level .GE. 10) THEN
              print *,'ale_bl_trig, alp_bl_stat ',ale_bl_trig, alp_bl_stat
@@ -160,13 +282,5 @@
 
           !cc fin nrlmd le 10/04/2012
-
-          ! ------------------------------------------------------------------
-          ! Transport de la TKE par les panaches thermiques.
-          ! FH : 2010/02/01
-          !     if (iflag_pbl.eq.10) then
-          !     call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
-          !    s           rg,paprs,pbl_tke)
-          !     endif
-          ! -------------------------------------------------------------------
+!
           !IM/FH: 2011/02/23 
           ! Couplage Thermiques/Emanuel seulement si T<0
@@ -180,6 +294,7 @@
                 endif
              enddo
+    print *,'In order to run with iflag_coupl=2, you have to comment out the following stop'
+             STOP
           endif
-!
    RETURN
    END
Index: /LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2594)
@@ -40,4 +40,5 @@
 !IM, MAFo fmagic, pmagic : parametres - additionnel et multiplicatif - 
 !                          pour regler l albedo sur ocean
+       REAL pbl_lmixmin_alpha
        REAL fmagic, pmagic
 ! Hauteur (imposee) du contenu en eau du sol
@@ -77,6 +78,7 @@
        REAL ecrit_LES
        REAL freq_ISCCP, ecrit_ISCCP
-       REAL freq_COSP
+       REAL freq_COSP, freq_AIRS
        LOGICAL :: ok_cosp,ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP
+       LOGICAL :: ok_airs
        INTEGER :: ip_ebil_phy, iflag_rrtm, iflag_ice_thermo, NSW, iflag_albedo
        LOGICAL :: ok_chlorophyll
@@ -94,5 +96,5 @@
      &     , CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt                     &
      &     , CH4_ppb_per, N2O_ppb_per, CFC11_ppt_per, CFC12_ppt_per     &
-     &     , cdmmax, cdhmax, ksta, ksta_ter, f_ri_cd_min                &
+     &     , cdmmax,cdhmax,ksta,ksta_ter,f_ri_cd_min,pbl_lmixmin_alpha  &
      &     , fmagic, pmagic                                             &
      &     , f_cdrag_ter,f_cdrag_oce,f_rugoro,z0min                     &
@@ -101,5 +103,5 @@
      &     , pasphys            , freq_outNMC, freq_calNMC              &
      &     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins             &
-     &     , freq_ISCCP, ecrit_ISCCP, freq_COSP                         &
+     &     , freq_ISCCP, ecrit_ISCCP, freq_COSP, freq_AIRS              &
      &     , cvl_corr                                                   &
      &     , qsol0,albsno0,evap0                                        &
@@ -120,5 +122,5 @@
      &     , lev_histins, lev_histLES, lev_histdayNMC, levout_histNMC   &
      &     , ok_histNMC                                                 &
-     &     , type_run, ok_regdyn, ok_cosp                               &
+     &     , type_run, ok_regdyn, ok_cosp, ok_airs                      &
      &     , ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP                     &
      &     , ip_ebil_phy                                                &
Index: /LMDZ5/branches/testing/libf/phylmd/cloudth.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cloudth.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/cloudth.F90	(revision 2594)
@@ -5,5 +5,4 @@
 
 
-      USE IOIPSL, ONLY : getin
       IMPLICIT NONE
 
@@ -20,4 +19,5 @@
 #include "FCTTRE.h"
 #include "thermcell.h"
+#include "nuage.h"
 
       INTEGER itap,ind1,ind2
@@ -54,5 +54,5 @@
       REAL sth,senv,sigma1s,sigma2s,xth,xenv
       REAL Tbef,zdelta,qsatbef,zcor
-      REAL alpha,qlbef  
+      REAL qlbef  
       REAL ratqs(ngrid,klev) ! determine la largeur de distribution de vapeur
       
@@ -62,34 +62,19 @@
       REAL erf
 
-      REAL, SAVE :: iflag_cloudth_vert, iflag_cloudth_vert_omp=0
-
-
-      LOGICAL, SAVE :: first=.true.
-
-
 
 
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-! Astuce pour gérer deux versions de cloudth en attendant
-! de converger sur une version nouvelle
+! Gestion de deux versions de cloudth
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      IF (first) THEN
-     !$OMP MASTER
-     CALL getin('iflag_cloudth_vert',iflag_cloudth_vert_omp)
-     !$OMP END MASTER
-     !$OMP BARRIER
-     iflag_cloudth_vert=iflag_cloudth_vert_omp
-      first=.false.
-      ENDIF
-       IF (iflag_cloudth_vert==1) THEN
-       CALL cloudth_vert(ngrid,klev,ind2,  &
+
+      IF (iflag_cloudth_vert.GE.1) THEN
+      CALL cloudth_vert(ngrid,klev,ind2,  &
      &           ztv,po,zqta,fraca, & 
      &           qcloud,ctot,zpspsk,paprs,ztla,zthl, &
      &           ratqs,zqs,t)
-       RETURN
-       ENDIF
+      RETURN
+      ENDIF
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
 
 
@@ -185,15 +170,8 @@
       cenv(ind1,ind2)=0.5*(1.+1.*erf(xenv)) 
       ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)   
-!      ctot(ind1,ind2)=alpha*cth(ind1,ind2)+(1.-1.*alpha)*cenv(ind1,ind2) 
-
-
 
       qlth(ind1,ind2)=sigma2s*((exp(-1.*xth**2)/sqrt2pi)+xth*sqrt(2.)*cth(ind1,ind2))
       qlenv(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))   
       qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
-!      qltot(ind1,ind2)=alpha*qlth(ind1,ind2)+(1.-1.*alpha)*qlenv(ind1,ind2)
-     
-
-!      print*,senv,sth,sigma1s,sigma2s,fraca(ind1,ind2),'senv et sth et sig1 et sig2 et alpha'
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -269,8 +247,4 @@
      &           ratqs,zqs,t)
 
-
-      IMPLICIT NONE
-
-
 !===========================================================================
 ! Auteur : Arnaud Octavio Jam (LMD/CNRS)
@@ -280,9 +254,14 @@
 
 
+      USE ioipsl_getin_p_mod, ONLY : getin_p
+
+      IMPLICIT NONE
+
 #include "YOMCST.h"
 #include "YOETHF.h"
 #include "FCTTRE.h"
 #include "thermcell.h"
-
+#include "nuage.h"
+      
       INTEGER itap,ind1,ind2
       INTEGER ngrid,klev,klon,l,ig 
@@ -320,6 +299,10 @@
       REAL IntJ,IntI1,IntI2,IntI3,coeffqlenv,coeffqlth
       REAL Tbef,zdelta,qsatbef,zcor
-      REAL alpha,qlbef  
+      REAL qlbef  
       REAL ratqs(ngrid,klev) ! determine la largeur de distribution de vapeur
+      ! Change the width of the PDF used for vertical subgrid scale heterogeneity
+      ! (J Jouhaud, JL Dufresne, JB Madeleine)
+      REAL,SAVE :: vert_alpha
+      LOGICAL, SAVE :: firstcall = .TRUE.
       
       REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
@@ -327,8 +310,4 @@
       REAL zqs(ngrid), qcloud(ngrid)
       REAL erf
-
-
-
-
 
 !------------------------------------------------------------------------------
@@ -355,5 +334,10 @@
       sqrtpi=sqrt(pi)
 
-
+      IF (firstcall) THEN
+        vert_alpha=0.5
+        CALL getin_p('cloudth_vert_alpha',vert_alpha)
+        WRITE(*,*) 'cloudth_vert_alpha = ', vert_alpha
+        firstcall=.FALSE.
+      ENDIF
 
 !-------------------------------------------------------------------------------
@@ -425,17 +409,10 @@
       cenv(ind1,ind2)=0.5*(1.+1.*erf(xenv)) 
       ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)   
-!      ctot(ind1,ind2)=alpha*cth(ind1,ind2)+(1.-1.*alpha)*cenv(ind1,ind2) 
-
-
 
       qlth(ind1,ind2)=sigma2s*((exp(-1.*xth**2)/sqrt2pi)+xth*sqrt(2.)*cth(ind1,ind2))
       qlenv(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))   
       qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
-!      qltot(ind1,ind2)=alpha*qlth(ind1,ind2)+(1.-1.*alpha)*qlenv(ind1,ind2)
      
-
-!      print*,senv,sth,sigma1s,sigma2s,fraca(ind1,ind2),'senv et sth et sig1 et sig2 et alpha'
-
-
+       IF (iflag_cloudth_vert == 1) THEN
 !-------------------------------------------------------------------------------
 !  Version 2: Modification selon J.-Louis. On condense ?? partir de qsat-ratqs
@@ -479,5 +456,57 @@
       qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
 
+      ELSE IF (iflag_cloudth_vert == 2) THEN
+
+!-------------------------------------------------------------------------------
+!  Version 3: Modification Jean Jouhaud. On condense a partir de -delta s
+!-------------------------------------------------------------------------------
+!      deltasenv=aenv*ratqs(ind1,ind2)*po(ind1)
+!      deltasth=ath*ratqs(ind1,ind2)*zqta(ind1,ind2)
+!      deltasenv=aenv*ratqs(ind1,ind2)*zqsatenv(ind1,ind2)
+!      deltasth=ath*ratqs(ind1,ind2)*zqsatth(ind1,ind2)
+      deltasenv=aenv*vert_alpha*sigma1s
+      deltasth=ath*vert_alpha*sigma2s
+      
+      xenv1=-(senv+deltasenv)/(sqrt(2.)*sigma1s)
+      xenv2=-(senv-deltasenv)/(sqrt(2.)*sigma1s)
+      xth1=-(sth+deltasth)/(sqrt(2.)*sigma2s)
+      xth2=-(sth-deltasth)/(sqrt(2.)*sigma2s)
+!     coeffqlenv=(sigma1s)**2/(2*sqrtpi*deltasenv)
+!     coeffqlth=(sigma2s)**2/(2*sqrtpi*deltasth)
+      
+      cth(ind1,ind2)=0.5*(1.-1.*erf(xth1))
+      cenv(ind1,ind2)=0.5*(1.-1.*erf(xenv1))
+      ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)
+
+      IntJ=0.5*senv*(1-erf(xenv2))+(sigma1s/sqrt2pi)*exp(-1.*xenv2**2)
+      IntI1=(((senv+deltasenv)**2+(sigma1s)**2)/(8*deltasenv))*(erf(xenv2)-erf(xenv1))
+      IntI2=(sigma1s**2/(4*deltasenv*sqrtpi))*(xenv1*exp(-1.*xenv1**2)-xenv2*exp(-1.*xenv2**2))
+      IntI3=((sqrt2*sigma1s*(senv+deltasenv))/(4*sqrtpi*deltasenv))*(exp(-1.*xenv1**2)-exp(-1.*xenv2**2))
+
+!      IntI1=0.5*(0.5*sqrtpi*(erf(xenv2)-erf(xenv1))+xenv1*exp(-1.*xenv1**2)-xenv2*exp(-1.*xenv2**2))
+!      IntI2=xenv2*(exp(-1.*xenv2**2)-exp(-1.*xenv1**2))
+!      IntI3=0.5*sqrtpi*xenv2**2*(erf(xenv2)-erf(xenv1))
+
+      qlenv(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+!      qlenv(ind1,ind2)=IntJ 
+!      print*, qlenv(ind1,ind2),'VERIF EAU'
+
+      IntJ=0.5*sth*(1-erf(xth2))+(sigma2s/sqrt2pi)*exp(-1.*xth2**2)
+      IntI1=(((sth+deltasth)**2+(sigma2s)**2)/(8*deltasth))*(erf(xth2)-erf(xth1))
+      IntI2=(sigma2s**2/(4*deltasth*sqrtpi))*(xth1*exp(-1.*xth1**2)-xth2*exp(-1.*xth2**2))
+      IntI3=((sqrt2*sigma2s*(sth+deltasth))/(4*sqrtpi*deltasth))*(exp(-1.*xth1**2)-exp(-1.*xth2**2))
+      
+      qlth(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+!      qlth(ind1,ind2)=IntJ
+!      print*, IntJ,IntI1,IntI2,IntI3,qlth(ind1,ind2),'VERIF EAU2'
+      qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
+      
+
+
+
+      ENDIF ! of if (iflag_cloudth_vert==1 or 2)
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
       if (cenv(ind1,ind2).lt.1.e-10.or.cth(ind1,ind2).lt.1.e-10) then
       ctot(ind1,ind2)=0.
Index: /LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 2594)
@@ -164,5 +164,5 @@
                iflag_pbl)
        ELSE IF (iflag_pbl<20) THEN
-          CALL yamada4(knon,dtime,RG,RD,ypaprs,yt, &
+          CALL yamada4(ni,nsrf,knon,dtime,RG,RD,ypaprs,yt, &
                yzlev,yzlay,yu,yv,yteta, &
                ycdragm,yq2,ykmm,ykmn,ykmq,yustar, &
